//+------------------------------------------------------------------+
//|                                                         MACD.mq4 |
//|                                Copyright  2005, David W. Thomas |
//|                                           mailto:davidwt@usa.net |
//|                               modified by Linuxser for Forex TSD |
//|                                        to look like eSignal MACD |
//|      added OSMA multicolor and Magnifier by brax64 for Forex TSD |
//+------------------------------------------------------------------+

// This is the correct computation and display of MACD.

#property copyright "Copyright  2005, David W. Thomas"
#property link      "mailto:davidwt@usa.net"


#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 DimGray
#property indicator_color2 Gainsboro
#property indicator_color3 C'35,95,235'
#property indicator_color4 Red
#property indicator_color5 DimGray
#property indicator_color6 DarkOrange


//---- input parameters


extern int       FastMAPeriod   = 12;
extern int       SlowMAPeriod   = 26;
extern int       SignalMAPeriod = 9;
extern double    Magnifier      = 1.5;


//---- buffers


double MACDLineBuffer[];
double SignalLineBuffer[];
double HistogramBufferUP[];
double HistogramBufferDN[];
double MACDHistoBuffer[];
double HistogramBuffer[];


//---- variables


double alpha = 0;
double alpha_1 = 0;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
  
  
   //---- indicators
   
   
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_DOT);       SetIndexBuffer(0,MACDHistoBuffer);      SetIndexDrawBegin(0,SlowMAPeriod);
   SetIndexStyle(1,DRAW_LINE, STYLE_SOLID, 1);       SetIndexBuffer(1,SignalLineBuffer);     SetIndexDrawBegin(1,SlowMAPeriod+SignalMAPeriod);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2);    SetIndexBuffer(2,HistogramBufferUP);    SetIndexDrawBegin(2,SlowMAPeriod+SignalMAPeriod);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,2);    SetIndexBuffer(3,HistogramBufferDN);    SetIndexDrawBegin(3,SlowMAPeriod+SignalMAPeriod);
   SetIndexStyle(4,DRAW_LINE, STYLE_SOLID,3);        SetIndexBuffer(4,MACDLineBuffer);       SetIndexDrawBegin(4,SlowMAPeriod);
   SetIndexStyle(5,DRAW_LINE, STYLE_SOLID,2);        SetIndexBuffer(5,HistogramBuffer);
   
   //---- name for DataWindow and indicator subwindow label
   
   
   IndicatorShortName("eMACD v1.0 ("+FastMAPeriod+","+SlowMAPeriod+","+SignalMAPeriod+")");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   
   
   //----
   
   
	alpha = 2.0 / (SignalMAPeriod + 1.0);
	alpha_1 = 1.0 - alpha;
	
	
   //----
   
   
   return(0);
}


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+


int deinit()
{
   //---- 
   
   //----
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()
{
   int limit;
   int counted_bars = IndicatorCounted();
   
   //---- check for possible errors
   
   if (counted_bars<0) return(-1);
   
   //---- last counted bar will be recounted
   
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;


   for(int i=limit; i>=0; i--)

   {
      MACDLineBuffer[i]    = iMA(NULL,0,FastMAPeriod,0,MODE_EMA,PRICE_CLOSE,i) - iMA(NULL,0,SlowMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);
      SignalLineBuffer[i]  = alpha*MACDLineBuffer[i] + alpha_1*SignalLineBuffer[i+1];
      MACDHistoBuffer[i]   = iMA(NULL,0,FastMAPeriod,0,MODE_EMA,PRICE_CLOSE,i) - iMA(NULL,0,SlowMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);
      
      HistogramBuffer[i] = (MACDLineBuffer[i] - SignalLineBuffer[i]) * Magnifier;
      HistogramBufferUP[i] = EMPTY_VALUE;
      HistogramBufferDN[i] = EMPTY_VALUE;
           
      if (HistogramBuffer[i] > 0)
      
         {
            HistogramBufferUP[i] = HistogramBuffer[i];
         }
            
      if (HistogramBuffer[i] < 0)
          
         {  
            HistogramBufferDN[i] = HistogramBuffer[i];
         }
   }
   
   //----
   
   
   return(0);
}


//+------------------------------------------------------------------+